/*
 *
 * Copyright(C) OASIS(R) 2010. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.    
 *   
 */

/**
 * C component implementation
 * 1 service with interface Service1
 * 0 references
 *
 * @author Bryan Aupperle
 *
 */

#include "Service6.h"
#include "SCA.h"

/* @Property */
char serviceName[50];

char *operation1(const char *input) {
	SCAREF callbackRef;
   	int compCode, reason, size = 50, num_values = 1;
	char *pServiceName = serviceName, response1[255], *result;

	SCAPropertyCString(L"serviceName", &pServiceName, &size, &num_values, &compCode, &reason);
	
	result = (char *)malloc(255);  /* infrastructure must free this */
	SCAGetCallback(L"", &callbackRef, &compCode, &reason);
	size = 255;
	SCAInvoke(callbackRef, L"callback1", strlen(input), (void *)input,
	          &size, (void *)response1, &compCode, &reason);

	SCAReleaseCallback(callbackRef, &compCode, &reason);
	strcpy(result, serviceName);
	strcat(result, " operation1 invoked ");
	strcat(result, response1);
	return result;
};
