/*
 * Copyright(C) OASIS(R) 2010. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.    
 */
package client;


import testClient.TestInvocation;

/**
 * Client for C_2013_TestCase
 * Tests that where one component is a client of a service provided by a second component, 
 * both with C implementations and which both run in the same address space, and the service 
 * implementation methods are marked with @AllowsPassByReference but the client is not marked 
 * with @AllowsPassByReference that invocations of the service use "pass by value" semantics.
 */
public class C_2013_TestCase extends BaseJAXWSTestRunner {

 
    protected TestConfiguration getTestConfiguration() {
    	TestConfiguration config = new TestConfiguration();
    	config.testName 		= this.getClass().getSimpleName().substring(0, 6);
    	config.input 			= "request";
    	config.output[0] 			= config.testName + " " + config.input + " service1 operation1 invoked service2 operation1 invoked request+1";
    	config.composite 		= "Test_" + config.testName + ".composite";
    	config.testServiceName 	= "TestClient";
    	config.testClass 		= null;
    	config.contributionNames	= new String[] { "ccni" };
    	config.serviceInterface = TestInvocation.class;
    	return config;
    }
    
} // end class Test_C_2013
