/*
 * Copyright(C) OASIS(R) 2010. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.    
 */
package client;


import testClient.TestInvocation;

/**
 * Client for C_3003_TestCase
 * Tests that SCA_<operation>Poll can be used with an interface marked requires="asyncInvocation".
 */
public class C_3003_TestCase extends BaseJAXWSTestRunner {

 
    protected TestConfiguration getTestConfiguration() {
    	TestConfiguration config = new TestConfiguration();
    	config.testName 		= this.getClass().getSimpleName().substring(0, 6);
    	config.input 			= "request";
    	config.output[0] 			= config.testName + " " + config.input + " service1 operation1 invoked operation2 invoked";
    	config.composite 		= "Test_" + config.testName + ".composite";
    	config.testServiceName 	= "TestClient";
    	config.testClass 		= null;
    	config.contributionNames	= new String[] { "ccni" };
    	config.serviceInterface = TestInvocation.class;
    	return config;
    }
    
} // end class Test_C_3003
