/*
 *
 * Copyright(C) OASIS(R) 2010. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.
 *
 */

/**
 * C component implementation with
 * 1 service with interface Service1
 * 0 references
 * 5 integral properties
 * @author Bryan Aupperle
 *
 */

#include "Service1.h"
#include "SCA.h"
#include <stdint.h>

/* @Property */
char serviceName[50];

/* @Property */
int8_t serviceData1;

/* @Property */
int16_t serviceData2;

/* @Property */
int32_t serviceData3;

/* @Property */
int64_t serviceData4;

/* @Property(type="xsd:hexBinary") */
int8_t serviceData5[4];

char *operation1(const char *input) {
	int compCode, reason, size = 50, num_values = 1;
	char *pServiceName = serviceName;
	int8_t *pServiceData5 = serviceData5;
	char *result;

	SCAPropertyCString(L"serviceName", &pServiceName, &size, &num_values, &compCode, &reason);
	SCAPropertyByte(L"serviceData1", &serviceData1, &num_values, &compCode, &reason);
	SCAPropertyShort(L"serviceData2", &serviceData2, &num_values, &compCode, &reason);
	SCAPropertyInt(L"serviceData3", &serviceData3, &num_values, &compCode, &reason);
	SCAPropertyLong(L"serviceData4", &serviceData4, &num_values, &compCode, &reason);
	size = 5;
	SCAPropertyBytes(L"serviceData5", &pServiceData5, &size, &num_values, &compCode, &reason);

	result = (char *)malloc(255);  /* infrastructure must free this */
	sprintf(result, "%s operation1 invoked %hhi %hi %li %lli %X\n",
	        serviceName, serviceData1, serviceData2, serviceData3, serviceData4, serviceData5);
	return result;
};
