/*
 *
 * Copyright(C) OASIS(R) 2010. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.
 *
 */

/**
 * C component implementation with
 * 1 service with interface Service1
 * 0 references
 * 6 properties
 * @author Bryan Aupperle
 *
 */

#include "Service1.h"
#include "SCA.h"
#include <wchar.h>

/* @Property */
char serviceName[50];

/* @Property */
wchar_t serviceData1[50];

/* @Property */
char serviceData2;

/* @Property */
wchar_t serviceData3;

/* @Property */
char serviceData4[5];

/* @Property */
wchar_t serviceData5[5];

char *operation1(const char *input) {
	int compCode, reason, size = 50, num_values = 1;
	char *pServiceName = serviceName, *pServiceData4 = serviceData4;
	wchar_t *pServiceData1 = serviceData1, *pServiceData5 = serviceData5;
	char *result;

	SCAPropertyCString(L"serviceName", &pServiceName, &size, &num_values, &compCode, &reason);
	size = 50;
	SCAPropertyString(L"serviceData1", &pServiceData1, &size, &num_values, &compCode, &reason);
	SCAPropertyCChar(L"serviceData2", &serviceData2, &num_values, &compCode, &reason);
	SCAPropertyChar(L"serviceData3", &serviceData3, &num_values, &compCode, &reason);
	size = 5;
	SCAPropertyCChars(L"serviceData4", &pServiceData4, &size, &num_values, &compCode, &reason);
	size = 5;
	SCAPropertyChars(L"serviceData5", &pServiceData5, &size, &num_values, &compCode, &reason);

	result = (char *)malloc(255);  /* infrastructure must free this */
	sprintf(result, "%s operation1 invoked %S %c %C %0.5s %0.5S\n",
	        serviceName, serviceData1, serviceData2, serviceData3, serviceData4, serviceData5);
	return result;
};
