/*
 *
 * Copyright(C) OASIS(R) 2010. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.
 *
 */

/**
 * C component implementation with
 * 1 service with interface Service1
 * 0 references
 * 1 complex property
 * @author Bryan Aupperle
 *
 */

#include "Service1.h"
#include "SCA.h"

/* @Property */
char serviceName[50];

struct serviceDataType {
	char firstData[50];
	char secondData[50];
};

/* @Property */
struct serviceDataType serviceData;

char *operation1(const char *input) {
	int compCode, reason, size = 50, num_values = 1;
	char *pServiceName = serviceName, *result;

	SCAPropertyCString(L"serviceName", &pServiceName, &size, &num_values, &compCode, &reason);
	SCAPropertyStruct(L"serviceData", (void *)&serviceData, &num_values, &compCode, &reason);

	result = (char *)malloc(255);  /* infrastructure must free this */
	strcpy(result, serviceName);
	strcat(result, " operation1 invoked");
	strcat(result, serviceData.firstData);
	strcat(result, serviceData.secondData);
	return result;
};
