/*
 *
 * Copyright(C) OASIS(R) 2010. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.
 *
 */

/**
 * C component implementation
 * 1 service with interface Service1
 * 1 service with interface Service16
 * 0 references
 *
 * @author Bryan Aupperle
 *
 */

#include "Service1.h"
#include "Service16.h"
#include "SCA.h"

/* @Property */
char serviceName[50];

char *operation1(const char *input) {
	SCAREF serviceToken;
	int compCode, reason, size = 50, num_values = 1;
	char *pServiceName = serviceName, response1[255], *result;

	SCAPropertyCString(L"serviceName", &pServiceName, &size, &num_values, &compCode, &reason);

	result = (char *)malloc(255);  /* infrastructure must free this */

	SCASelf(L"Service16", &serviceToken, &compCode, &reason);
	size = 255;
	SCAInvoke(serviceToken, L"operation1", strlen(input), (void *)input,
	          &size, (void *)response1, &compCode, &reason);

	strcpy(result, serviceName);
	strcat(result, " operation1 invoked ");
	strcat(result, response1);
	return result;
};

char *operation2(const char *input) {
	int compCode, reason;
	char *result;

	result = (char *)malloc(255);  /* infrastructure must free this */
	strcpy(result, "operation2 invoked");
	return result;
};
