/*
 *
 * Copyright(C) OASIS(R) 2010. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.
 *
 */

/**
 * C component implementation with
 * 1 service with interface Service1,
 * 1 reference (1..1) with interface Service5 which has a Callback
 * interface which is implemented by this class
 * reference gets called when service1 operation1 is invoked
 * @author Bryan Aupperle
 *
 */


#include "Service1P.h"
#include "Service5CallbackP.h"
#include "SCA.h"

/* @Property */
char serviceName[50];

/* @Reference(name="reference1", interfaceHeader="Service5P.h") */

char result[255];

main () {
    wchar_t myService [255];
    wchar_t myOperation [255];
    struct operation1 request;
    struct operation1Response response;
    struct callback1Response cb_response;
	SCAREF serviceToken;
	int compCode, reason, size = 50, num_values = 1;
	char *pServiceName = serviceName, response1[255];

	SCAPropertyCString(L"serviceName", &pServiceName, &size, &num_values, &compCode, &reason);

    SCAService(myService, &compCode, &reason);

    SCAOperation(myOperation, &compCode, &reason);

    if (wcscmp(myService,L"Service1P") == 0 && wcscmp(myOperation,L"operation1") == 0) {
    	SCAMessageIn(myService, myOperation, sizeof(struct operation1), (void *)&request,
                     &compCode, &reason);

		SCAGetReference(L"reference1", &serviceToken, &compCode, &reason);
		size = 255;
		SCAInvoke(serviceToken, L"operation1", strlen(request.input), (void *)request.input,
	              &size, (void *)response1, &compCode, &reason);

		strcpy(response.result, serviceName);
		strcat(response.result, " operation1 invoked ");
		strcat(response.result, response1);
        SCAMessageOut(myService, myOperation, sizeof(struct operation1Response),(void *)&response,
                      &compCode, &reason);
    }
    else if (wcscmp(myService,L"Service5CallbackP") == 0 && wcscmp(myOperation,L"callback1") == 0) {
        SCAMessageOut(myService, myOperation, sizeof(struct callback1Response),(void *)&cb_response,
                      &compCode, &reason);
		strcpy(cb_response.result, serviceName);
		strcat(cb_response.result, " callback1 invoked");
    }
};
