/*
 *
 * Copyright(C) OASIS(R) 2010. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.
 *
 */

/**
 * C component probram-based implementation with
 * 1 service with interface Service1P,
 * 1 reference (1..1) with interface Service111P
 * reference gets called service1 operation1 is invoked
 *
 * @author Bryan Aupperle
 *
 */

#include "Service1P.h"
#include "SCA.h"

/* @Property */
char serviceName[50];

/* @Reference(name="reference1", interfaceHeader="Service11P.h") */

main () {
    wchar_t myService [255];
    wchar_t myOperation [255];
    struct operation1 request;
    struct operation1Response response;
	SCAREF serviceToken;
	int compCode, reason, size = 50, num_values = 1;
	char *pServiceName = serviceName, response1[255];

	SCAPropertyCString(L"serviceName", &pServiceName, &size, &num_values, &compCode, &reason);

    SCAService(myService, &compCode, &reason);

    SCAOperation(myOperation, &compCode, &reason);

    if (wcscmp(myOperation,L"operation1") == 0){
		SCAGetReference(L"reference1", &serviceToken, &compCode, &reason);
		size = 255;
		SCAInvoke(serviceToken, L"operation1", strlen(request.input), (void *)request.input,
	              &size, (void *)response1, &compCode, &reason);
		switch (compCode) {
			case (SCACC_ERROR):
				strcpy(response.result, "Test service got an error during execution: ");
				switch (reason) {
					case (SCA_PARAMETER_ERROR):
						strcat(response.result, "Incorrect parameter value");
						break;
					case (SCA_RUNTIME_ERROR):
						strcat(response.result, "Other runtime detected error");
						break;
					default:
						strcat(response.result, "Other error");
				}
				break;

			case (SCACC_OK):
				strcpy(response.result, serviceName);
				strcat(response.result, " operation1 invoked ");
				strcat(response.result, response1);
				break;

			default:
				/* Should not get here */
				response.result[0] = '\0';
		}

        SCAMessageOut(myService, myOperation, sizeof(struct operation1Response),(void *)&response,
                      &compCode, &reason);
    }
};
