/*
 *
 * Copyright(C) OASIS(R) 2010. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.
 *
 */

/**
 * A test service interface for a program-based implementation with an operation
 * with request and response message struct members with the same name but different
 * types
 * @author Bryan Aupperle
 *
 */

struct aa {
	int     m;
	char    n[10];
	long    o[5];
};

/* @Remotable */
/**
 * Message formats for invoking testcase service
 * input parameter(s) as a char array
 * output data as a char array
 */
struct operation1 {
	char input[50];
};

struct operation1Response {
	char result[255];
};

/**
 * Message formats for invoking testcase service
 * input parameters as a struct and a float
 * output data short
 */
struct operation2 {
	struct aa a;
	float b;
};

struct operation2Response {
	short result;
};
