/*
 *
 * Copyright(C) OASIS(R) 2010. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.
 *
 */

/**
 * C component implementation
 * 1 service with interface Service34
 * 1 service with interface Service35
 * 0 references
 *
 * @author Bryan Aupperle
 *
 */

#include "Service34.h"
#include "Service35.h"
#include "SCA.h"

/* @Property */
wchar_t serviceName[50];

/* @Service(interfaceHeader="Service34.h */
wchar_t *operation1(const wchar_t *input) {
	int compCode, reason, size = 50, num_values = 1;
	wchar_t *pServiceName = serviceName, *result;

	SCAPropertyString(L"serviceName", &pServiceName, &size, &num_values, &compCode, &reason);

	result = (wchar_t *)malloc(255);  /* infrastructure must free this */
	wcscpy(result, serviceName);
	wcscat(result, L" operation1 invoked");
	return result;
};

/* @Service(interfaceHeader="Service35.h */
wchar_t *operation2(const wchar_t *input) {
	int compCode, reason, size = 50, num_values = 1;
	wchar_t *pServiceName = serviceName, *result;

	SCAPropertyString(L"serviceName", &pServiceName, &size, &num_values, &compCode, &reason);

	result = (wchar_t *)malloc(255);  /* infrastructure must free this */
	wcscpy(result, serviceName);
	wcscat(result, L" operation2 invoked");
	return result;
};
